#include<stdio.h>
#include<stdlib.h>
#include"/usr/src/linux/include/linux/version.h"

void parse_version(char*string,int*major,int*minor,int*release)
{ if(sscanf(string,"%d.%d.%d",major,minor,release)!=3)
  { printf("autoinstall: parse_version: %s not recognized!\n",string);
    exit(3);
  }
}

int compare_version(char*string1,char*string2)
{ int major1,minor1,release1;
  int major2,minor2,release2;
  
  parse_version(string1,&major1,&minor1,&release1);
  parse_version(string2,&major2,&minor2,&release2);
  
  if(major1>major2)return 1;
  if(major1<major2)return -1;
  if(minor1>minor2)return 1;
  if(minor1<minor2)return -1;
  if(release1>release2)return 1;
  if(release1<release2)return -1;
  return 0;
}

int main(void)
{ char* script=NULL;

  /* simply decide which script to execute */
  if(compare_version(UTS_RELEASE,"1.2.10")<0)
  { printf("Your configuration is untested (very old kernel).\n");
    script="./INSTALL_1.2";
  }
  else if(compare_version(UTS_RELEASE,"1.3.0")<0) script="./INSTALL_1.2";
  else if(compare_version(UTS_RELEASE,"1.3.39")<0) script="./INSTALL_1.3";
  else if(compare_version(UTS_RELEASE,"1.3.81")<0) script="./INSTALL_1.3.4x";
  else if(compare_version(UTS_RELEASE,"1.3.94")<0) script="./INSTALL_1.3.8x";
  else if(compare_version(UTS_RELEASE,"1.99.0")<0) script="./INSTALL_1.3.94";
  else if(compare_version(UTS_RELEASE,"2.0.1")<0) script="./INSTALL_2.0.0";
  else if(compare_version(UTS_RELEASE,"2.1.0")<0) script="./INSTALL_2.0.1";
  else if(compare_version(UTS_RELEASE,"2.1.6")<0) script="./INSTALL_2.1.5";
  else
  { printf("Your configuration is untested (very new kernel).\n");
    script="./INSTALL_2.1.5";
  }
  
  printf("Trying installation script %s...\n",script);
  
  system(script);
  return 0;
}



